package app;

import java.security.KeyPair;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;

import budrys.security.Crypt;

public class TestCrypt {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		KeyPair kp = Crypt.generateKeys();
		
		// szyfrowanie i odszyfrowanie
		String message = "wiadomo TESSSSTOWA!";
		String encrypted = Crypt.encryptMessage(message, (RSAPublicKey) kp.getPublic());
		System.out.println(encrypted);
		String decrypted = Crypt.decryptMessage(encrypted, (RSAPrivateKey) kp.getPrivate());
		System.out.println(decrypted);
		
		// podpis i weryfikacja		
		String signature = Crypt.signMessage("testowa wiadomo!", (RSAPrivateKey)kp.getPrivate());
		System.out.println(signature);
		boolean verified = Crypt.verifySignature("testowa wiadomo!", signature, (RSAPublicKey)kp.getPublic());
		System.out.println(verified);
		verified = Crypt.verifySignature("testowa wiadomo!", signature, (RSAPublicKey)kp.getPublic());
		System.out.println(verified);
//		
//		// zapis i odczyt klucza
//		RSAPublicKey pub = (RSAPublicKey)kp.getPublic();
//		String pubStr = Crypt.encodeKey(pub);
//		System.out.println(pubStr);
//		RSAPublicKey pub2 = Crypt.decodePublicKey(pubStr);
//		String pubStr2 = Crypt.encodeKey(pub2);
//		System.out.println(pubStr2);
//		
//		RSAPrivateKey priv = (RSAPrivateKey)kp.getPrivate();
//		String privStr = Crypt.encodeKey(priv);
//		System.out.println(privStr);
//		RSAPrivateKey priv2 = Crypt.decodePrivateKey(privStr);
//		String privStr2 = Crypt.encodeKey(priv2);
//		System.out.println(privStr2);
	}

}
