package app;

import budrys.*;
import budrys.chord.IfcCallback;
import budrys.security.Crypt;
import budrys.social.ProfileModel;
import budrys.social.ProfileService;
import budrys.social.RemoteProfile;
import budrys.transport.socket.TransportClient;
import budrys.transport.socket.TransportServer;

public class TestProfile {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ProfileModel pm = new ProfileModel("Micha", "Pawluczuk", "Warsaw, Poland", true);
		pm.setAvatarPath("avatar.png");
		pm.setAvatarPath("patrh/sad/asdasda/asdaf.png");
		System.out.println("-- ALL --");
		System.out.println(pm.exportAllToJson());
		ProfileModel pm2 = new ProfileModel(pm.exportAllToJson().toString());
		System.out.println(pm2.exportAllToJson());
		System.out.println("data: "+pm2.exportAllToJson().toString().equals(pm.exportAllToJson().toString()));
		System.out.println("sig:  "+pm2.isSignatureVerified());
		System.out.println("---------");
		System.out.println("-- PUB --");
		System.out.println(pm.exportPublicToJson());
		pm2 = new ProfileModel(pm.exportPublicToJson().toString());
//		System.out.println(pm2.getSignature());
		System.out.println(pm2.exportPublicToJson());
		System.out.println("data: "+pm2.exportPublicToJson().toString().equals(pm.exportPublicToJson().toString()));
		System.out.println("sig:  "+pm2.isSignatureVerified());
		System.out.println("---------");
		System.out.println("-- RES --");
		System.out.println(pm.exportRestrictedToJson());
		pm2 = new ProfileModel(pm.exportRestrictedToJson().toString());
		System.out.println(pm2.exportRestrictedToJson());
		System.out.println("data: "+pm2.exportRestrictedToJson().toString().equals(pm.exportRestrictedToJson().toString()));
		System.out.println("sig:  "+pm2.isSignatureVerified());
		System.out.println("---------");
		System.out.println(Crypt.encodeKey(pm2.getPublicKey()));
		
//		ProfileService ps = new ProfileService((short)15045, new TransportServer(), pm);
//		RemoteProfile rp = new RemoteProfile("127.0.0.1:"+(short)15045, new TransportClient());
//		rp.getProfileData(new IfcCallback() {
//			public void success(String command, String argument, Object callback) {
//				ProfileModel pm3 = new ProfileModel(argument);
//				System.out.println("obtained: "+pm3.exportAllToJson());
//			}
//
//			public void failure(Exception e, Object reason) {
//				System.out.println("exception: "+reason);
//			}
//		});
//		try {
//			Thread.sleep(2000);
//		} catch (InterruptedException e1) {
//			// TODO Auto-generated catch block
//			e1.printStackTrace();
//		}
//		ps.stopService();
	}

}
