/**
 * 
 * @author Micha Pawluczuk
 *
 *	TODO
 *	- testy losowego dolaczania i node failure
 */
package app;

import budrys.chord.*;
import budrys.transport.socket.TransportClient;
import budrys.transport.socket.TransportServer;

public class TestChord {
	public static final int PEERS_NUMBER = 10;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ChordDHT[] chords = new ChordDHT[PEERS_NUMBER];
		
		/*Long aa = Long.valueOf("78357f0000012782", 16);
		System.out.println("aa:" + aa.toHexString(aa));
		System.out.println("aa:" + aa);
		Long bb = aa+aa+Long.MAX_VALUE;
		System.out.println("bb:" + bb.toHexString(bb));
		System.out.println("bb:" + bb);
		bb = bb-aa;
		//System.out.println("b-:" + bb.toHexString(bb));
		System.out.println("b-:" + bb);*/
		
		try {
			for (int i=0; i<PEERS_NUMBER; ++i){
				chords[i] = new ChordDHT("127.0.0.1", (short)((short)10101+(short)i), "127.0.0.1", (short)10101, new TransportServer(), new TransportClient());
				if (i==0){
					chords[i].startChordSync();
				} else {
					chords[i].startChordAsync(null);
				}
				System.out.println("Created: "+i);
				Thread.sleep(10);				
			}
			
			
			Thread.sleep(2000);
			System.out.println("");
			System.out.println("[");
			for (int i=0; i<PEERS_NUMBER; ++i){
				if (i>0){
					System.out.print(", ");
				}
				System.out.println(chords[i].debugInfoJSON());	
			}
			System.out.println("]");		
			
			// GIVING SOME TIME TO STABILIZE
			Thread.sleep(5000);
		
			//while(true){
				//Thread.sleep(5000);
				System.out.println("");
				System.out.println("[");
				for (int i=0; i<PEERS_NUMBER; ++i){
					if (i>0){
						System.out.print(", ");
					}
					System.out.println(chords[i].debugInfoJSON());	
				}
				System.out.println("]");				
			//}
				
			// ONE NODE GOES DOWN 
			//chords[1].stopChord();
			//chords[3].stopChord();
			
			boolean a = true;
			while(a){
				Thread.sleep(3000);
				System.out.println("");
				System.out.println("[");
				for (int i=0; i<PEERS_NUMBER; ++i){
					//if (i != 1) {
						if (i>0){
							System.out.print(", ");
						}
						System.out.println(chords[i].debugInfoJSON());
					//}
				}
				System.out.println("]");				
			}
			
				
			// TESTING DHT CONSISTENCY
//			Long currentId = chords[2].getId();
//			for (int i=1; i<PEERS_NUMBER; ++i){
//				Peer informator = new Peer(currentId, new TransportClient());
//				Long inforPred = null;
//				while (inforPred == null){
//					inforPred = informator.getPredecessorSync();
//					Thread.sleep(1500);
//					//informator = new Peer(currentId, new TransportClient());
//				}
//				//System.out.println("id:"+currentId+"inforPred:"+inforPred);
//				Log.i("id:"+Log.idFormat(currentId)+"; inforPred:"+Log.idFormat(inforPred));
//				//Long inforPredPred = informator.closestPrecedingNodeSync(inforPred);
//				//System.out.println(currentId+" -< "+inforPred+" -< "+inforPredPred);
//				currentId = inforPred;
//			}
//			
//			
//			System.out.println("");
//			System.out.println("[");
//			for (int i=1; i<PEERS_NUMBER; ++i){
//				if (i>1){
//					System.out.print(", ");
//				}
//				System.out.println(chords[i].debugInfoJSON());	
//			}
//			System.out.println("]");		
			
			
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
		
		
		
		
//		try {
//			Chord chord1 = new Chord("127.0.0.1", (short)10101, "127.0.0.1", (short)10101, new TransportServer(), new TransportClient());
//			Thread.sleep(100);
//			Chord chord2 = new Chord("127.0.0.1", (short)10102, "127.0.0.1", (short)10101, new TransportServer(), new TransportClient());
//			Thread.sleep(100);
//			Chord chord3 = new Chord("127.0.0.1", (short)10103, "127.0.0.1", (short)10101, new TransportServer(), new TransportClient());
//			Thread.sleep(100);
//			Chord chord4 = new Chord("127.0.0.1", (short)10104, "127.0.0.1", (short)10101, new TransportServer(), new TransportClient());
//			Chord chord5 = new Chord("127.0.0.1", (short)10105, "127.0.0.1", (short)10101, new TransportServer(), new TransportClient());
//			
//			Thread.sleep(10000);
//			System.out.println("========== DEBUG BEGIN ============");
//			System.out.println(chord1.debugInfo());
//			System.out.println(chord2.debugInfo());
//			System.out.println(chord3.debugInfo());
//			System.out.println(chord4.debugInfo());
//			System.out.println(chord5.debugInfo());
//			System.out.println("========== DEBUG END ==============");
//			
//		} catch (InterruptedException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
		
		
		
		//System.out.println(chord4.debugInfo());
		//System.out.println(chord5.debugInfo());
		
		//System.out.println("MyID: " + chord1.getId());
		//System.out.println("MyID: " + chord2.getId());
		
		//ID myID = new ID("127.0.0.1", (short)6666);
		//System.out.println(myID.debugInfo());
	}

}
